<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body" id="cardBody">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入文件名">
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="fileType" name="fileType">
                                <option value="">选择类型</option>
                                <option value="image">图片</option>
                                <option value="video">视频</option>
                                <option value="audio">音频</option>
                                <option value="file">文件</option>
                            </select>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>

<script src="assets/layuiadmin/layui/layui.js"></script>
<script type="text/javascript">
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;
        var tableUrl = 'api/file/v2/listpage';
        var previewTypeArray = [
            'png','jpg','jpeg','gif','blob',
            'mp4',
            'mp3', 'wav',
            'pdf'
        ]

        /**
         * 是否是预览类型
         * @param fileType
         * @return {boolean}
         */
        function isPreviewType(fileType) {
            for(var i = 0, item; item = previewTypeArray[i++];) {
                if(fileType.toLowerCase() == item) {
                    return true;
                }
            }
            return false;
        }

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type: 'checkbox', fixed: 'left'},
                        {field: 'rowNum', width: 80, title: '序号', fixed: 'left', align: 'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'fileId', width: 300, title: '主键', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileName', width: 200, title: '文件名称', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'filePath', width: 300, title: '存放位置', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileUrl', width: 300, title: '访问地址', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileType', width: 100, title: '文件类型', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileSize', width: 120, title: '文件大小', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'fileSummary', width: 200, title: '文件描述', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'creator', width: 150, title: '创建人', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'gmtCreate', width: 180, title: '创建时间', align: 'center',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'preview', width: 90, title: '预览', align: 'center', fixed: 'right',
                            templet: function (row) {
                                if(isPreviewType(row.fileType)) {
                                    return '<a href="route/file/v2/download/true/'+ row.fileId +'" target="_blank" title="点击预览" class="layui-btn layui-btn-xs" ><i class="fa fa-eye" aria-hidden="true"></i> 预览</a>'
                                }
                                return '-'
                            }
                        },
                        {field: 'download', width: 90, title: '下载', align: 'center', fixed: 'right',
                            templet: function (row) {
                                return '<a href="route/file/v2/download/false/'+ row.fileId +'" target="_blank" title="点击下载" class="layui-btn layui-btn-xs layui-btn-normal" ><i class="fa fa-cloud-download" aria-hidden="true"></i> 下载</a>'
                            }
                        },
                        {field: 'downloadCount', width: 100, title: '下载次数', align: 'center', fixed: 'right',
                            templet: function (row) {
                                var rowData = row[this.field];
                                if (typeof (rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '0';
                                }
                                if(rowData == 0) {
                                    return rowData;
                                }
                                return '<button class="layui-btn layui-btn-xs layui-btn-danger" lay-event="showDownloadFilter">'+ rowData +'次</button>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function (data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }

        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    fileType: $('#fileType').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }

        function deleteData(ids) {
            top.dialog.confirm('删除记录与源文件', function() {
                var layIndex;
                top.restAjax.delete(top.restAjax.path('api/file/v2/delete/{ids}', [ids]), {}, null, function (code, data) {
                    top.dialog.msg('删除成功', {time: 1000});
                    reloadTable();
                }, function (code, data) {
                    top.dialog.msg(data.msg);
                }, function () {
                    layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                }, function () {
                    top.dialog.close(layIndex);
                });
            });
        }

        initTable();

        // 事件 - 页面变化
        $win.on('resize', function () {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function () {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function () {
            reloadTable(1);
        });

        // 事件 - 增删改
        table.on('toolbar(dataTable)', function (obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if (layEvent === 'removeEvent') {
                if (checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for (var i = 0, item; item = checkDatas[i++];) {
                        if (i > 1) {
                            ids += '_';
                        }
                        ids += item['fileId'];
                    }
                    deleteData(ids);
                }
            }
        });

        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var event = obj.event;
            if(event === 'showDownloadFilter') {
                top.dialog.open({
                    title: '下载记录',
                    url: top.restAjax.path('route/file-download/list?fileId={fileId}', [data.fileId]),
                    width: '500px',
                    height: '500px',
                })
            }
        });
    })
</script>
</body>
</html>